<?php
# Copyright (C) 2011 Matthew Wronka <murder@projects.matt.wronka.org>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the
# License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

require_once('php/system/basicuser.inc');

class MurderAuth
{
	static private $instance = false;
	private $authenticators = array();
	
	private function __construct()
	{
	}

	static public function getInstance()
	{
		if(!MurderAuth::$instance)
		{
			MurderAuth::$instance = new MurderAuth();
		}
		return MurderAuth::$instance;
	}

	public function addAuthUrl($url, $label)
	{
		$this->authenticators[$url] = $label;
	}

	static public function hasAuth()
	{
		return 0!=sizeof($this->getInstance()->authenticators);
	}

	static public function getUser()
	{
		return safeGet($_SESSION, 'AUTH_USER');
	}

	static public function setUser($user)
	{
		if($user) $_SESSION['AUTH_USER'] = $user;
		else unset($_SESSION['AUTH_USER']);
	}
}

class AuthenticatedUser extends BasicUser
{
	public function __construct($login) { $this->login = $login; }
	public function set($k, $v) { if($k) $this->self[$k] = $v; }
	public function getMap() { return $this->self; }
}



?>
