<?php
# Copyright (C) 2011 Matthew Wronka <murder@projects.matt.wronka.org>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the
# License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

require_once('php/system/basicuser.inc');
require_once('php/system/localuser.inc');
class UserStore
{
	static private $instance = false;
	private $users = array();
	function __construct()
	{
		if( $userFile = config('USER_LIST') )
			$passwd = file($userFile);
		else
			exec("getent passwd", $passwd);
		if($passwd) foreach($passwd as $line)
		{
			$groupStore = GroupStore::getInstance();
			$u = new Localuser($line);
			if($groupStore->isUserMember($u->getLogin(),config('GROUP')))
			{
				if(!$u->isHidden())
				{
					$this->users[$u->getLogin()] = $u;
				}
			}
		}

	}

	static public function getInstance()
	{
		if(!UserStore::$instance)
		{
			UserStore::$instance = new UserStore();
		}
		return UserStore::$instance;
	}

	public function getUser($name)
	{
		return safeGet($this->users, $name, false);
	}

	public function getUsers()
	{
		return $this->users;
	}

}

class GroupStore
{
	static private $instance = false;
	private $groups = array();
	function __construct()
	{
		if( $groupFile = config('GROUP_LIST') )
			$groups = file($groupFile);
		else
			exec("getent group", $groups);
		if($groups) foreach($groups as $line)
		{
			$split = explode(':', trim($line));
			$name = $split[0];
			$users= explode(',', $split[3]);
			$this->groups[$name] = array();
			foreach($users as $u)
			{
				$this->groups[$name][$u] = true;
			}
		}

	}

	static public function getInstance()
	{
		if(!GroupStore::$instance)
		{
			GroupStore::$instance = new GroupStore();
		}
		return GroupStore::$instance;
	}

	public function isUserMember($user, $group)
	{
		$g = safeGet($this->groups,$group);
		if(!$g) return false;
		return safeGet($g, $user);
	}

	public function getMembers($group) { return $this->groups[$group]; }
}
?>
