<?php
# Copyright (C) 2011 Matthew Wronka <murder@projects.matt.wronka.org>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the
# License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

class MailBoardReader
{

	private static function _readMessage($file)
	{
		$contents = is_readable($file)?file($file):array();
		$headers = array();
		$body  = false;
		$bEndedHeaders = false;
		foreach($contents as $f)
		{
			if($bEndedHeaders)
			{
				$n = strlen($f);
				$f = substr($f, 0, --$n);
				if($f && substr($f,$n-1,1)== '=')
				{
					$l = substr($f, 0, $n-1);
				} else $l = $f . "\n";
				$body .= MailBoardRendererUtil::unquote($l) ;
				continue;
			}
			if(trim($f) == '')
			{
				$bEndedHeaders = true;
				continue;
			}
			list($k, $v) = xsplit(':', $f, 2);
			$headers[strtolower(trim($k))] = trim($v);	// smash other values of $k
			// TODO: support folded headers!
		}
		$author = safeGet($headers, 'from');
		$subject= safeGet($headers, 'subject');
		$date   = safeGet($headers, 'date');
		return new MailBoardRendererMessage($author, $subject, $date, $body);
	}

	private static function _getMessages($mailbox)
	{
		$r = array();
		$mailbox = $mailbox.'cur/';	# not-new messages
		if(!is_dir($mailbox)) return $r;
		if(!is_readable($mailbox)) return $r;
		$files = scandir($mailbox);
		if(!$files) return $r;
		foreach($files as $f)
		{
			if(substr($f, 0, 1) != '.')
			{
				$r[] = MailBoardReader::_readMessage($mailbox .'/' . $f);
			}
		}
		return $r;
	}

	public static function read($user)
	{
		if(!$user) return false;
		$mailbox = MailBoardRendererUtil::getMailbox($user);
		$posts = MailBoardReader::_getMessages($mailbox);
		return $posts;
	}

}
?>
