<?php
# Copyright (C) 2011 Matthew Wronka <murder@projects.matt.wronka.org>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the
# License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

class MailBoardRendererMessage
{
	private $body;
	private $subject;
	private $author;
	private $date;

	public function __construct($author, $subject, $date, $body)
	{
		$this->body = MailBoardRendererMessage::clean($body);
		$this->author = trim($author);
		$this->subject = trim($subject);
		$this->date = strtotime(trim($date));
		if(!substr_compare($this->subject, 're:',0,3, true))
		{
			$this->subject = trim(substr($this->subject,3));
		}
	}

	public function getBody() 
	{ 
		return $this->body; 
	}
	public function getAuthor() { return $this->author; }
	public function getSubject() { return $this->subject; }
	public function getDate() 
	{ 
			$fstr = "%F";	// default is a date
			$diff = time() - $this->date;
			if($diff < (22 * 60 * 60))
			{
				$fstr = "%r";	// just a time
			}
			return strftime($fstr, $this->date); 
	}
	public function getTime() { return $this->date; }


	protected function clean($body)
	{
		$x = preg_split('/[\r\n]-- [\r\n]/', $body,2, PREG_SPLIT_NO_EMPTY );
		return trim($x[0]);
	}
} 

?>
